// Settings
var ccisApiUrl = "https://eventusgdev.com/ccis-app-v1_1/";
//var ccisApiUrl = "http://localhost:3000/ccis-app/";

var partitionList = [
    {
        name: 'Partition A',
        value: 'A'
    },
    {
        name: 'Partition B',
        value: 'B'
    },
    {
        name: 'Partition C',
        value: 'C'
    }
];

var moduleList = [
     {
        name: 'account',
        defaultPartition: 'C',
        defaults: {
            'hooTremnt': '',
            'holAcctPrmptMsg': '',
            'holReqDgts': '',
            'clsdAcctPrmptMsg': '',
            'ecpAcctPrmptMsg': '',
            'ecpReqDgts': '',
            'mtgAcctPrmptMsg': '',
            'mtgReqDgts': '',
            'opnAcctPrmptMsg': '',
            'opnReqDgts': ''
        }
    },
    {
        name: 'agentEval',
        defaultPartition: 'B',
        defaults: {
            'k1': 'v1'
        }
    },
    
 
     {
        name: 'clntld',
        defaultPartition: 'B',
        defaults: {
            'callBlckBypass': '',
            'busRedirect': '',
            'canada': ''
        }
    },
        {
        name: 'clnAuth',
        defaultPartition: 'C',
        defaults: {  
			'opnMsg': '',
			'holMsg': '',
			'clsdMsg': '',
			'mtgMsg': '',
			'ecpMsg': ''
        }
    },

    {
        name: 'clntSeg',
        defaultPartition: 'C',
        defaults: {
            'intent': '',
            'seg': '',
            'stateCd': '',
			'defskill': '',
			'extskill': ''
        }
    },

        {
        name: 'disco',
        defaultPartition: 'A',
        defaults: {
            'holMsg': '',
            'clsdMsg': '',
            'mtgMsg': '',
            'ecpMsg': '',
			'disco': ''
        }
    },
        {
        name: 'enroute',
        defaultPartition: 'B',
        defaults: {
            'pos1': '',
            'pos2': '',
            'pos3': '',
            'pos4': '',
            'prmpt': ''
        }
    },
      {
        name: 'getTrg',
        defaultPartition: 'C',
        defaults: {
            'k1': 'v1'
        }
    },
        {
        name: 'hoo',
        defaultPartition: 'A',
        defaults: {
            'gHolId': '',
            'opnId': '',
            'holActn': '',
            'clsdActn': '',
            'ecpFlag': '0',
            'ecpActn': '',
            'mtgFlag': '0',
            'mtgActn': '',
            'vcbFlag': '0',
            'vcbId': '0'
        }
    },
    {
        name: 'init',
        defaultPartition: 'A',
        defaults: {
            'templateVer': '',
            'type': ''
        }
    },
    {
        name: 'ivr',
        defaultPartition: 'C',
        defaults: {
            'k1': 'v1'
        }
    },

    {
        name: 'prompt',
        defaultPartition: 'A',
        defaults: {
            'k1': 'v1'
        }
    },

         {
        name: 'queue',
        defaultPartition: 'B',
        defaults: {
           'ruleCfg': '',
			'qMoh': '',
			'msg': '',
			'msgNR': '',
			'skill': '',
			'ewtOnly': '',
			'int': '',
			'delay': '',
			'qEmergTime': '',
			'qEmergSkill': '',
			'qEmergMsg': '',
			'qMaxTrig': '',
			'dur': '',
			'OptOutMsg': '',
			'DiscoTime': '',
			'DiscoAfterVM': '',
			'DiscoMsg': ''
        }
    },
    {
        name: 'queueAgnt',
        defaultPartition: 'B',
        defaults: {
            'k1': 'v1'
        }
    },
   
    {
        name: 'spclSeg',
        defaultPartition: 'C',
        defaults: {
			'ruleCfg': ''

        }
    },
   

    

        {
        name: 'trgEval',
        defaultPartition: 'B',
        defaults: {
            'k1': 'v1'
        }
    }, {
        name: 'upFrnt',
        defaultPartition: 'C',
        defaults: {
            'holGrt': '',
            'holEmg': '',
            'clsdGrt': '',
            'clsdEmg': '',
            'opnGrt': '',
            'opnEmg': '',
            'qaMsg': ''
        }
    },
    
        {
        name: 'vm',
        defaultPartition: 'B',
        defaults: {
            'tmVmSkl': '',
			'tmVmDist': '',
			'hooActn': '',
			'ann': '',
			'disco': '',
			'vm': ''
			
        }
    }
  
];

var buConfigs = [
    {
        bu: '4600423',
        name: 'Eventus',
        cluster: 'B32',
        workItemPoc: '53852086-Scholl_Demo_Work_Item'
    },
    {
        bu: '4600852',
        name: 'Schwab DEV',
        cluster: 'C39',
        workItemPoc: '52165185-hostedCcis'
    },
    {
        bu: '4600824',
        name: 'Schwab UAT',
        cluster: 'C39',
        workItemPoc: '52165185-hostedCcis'
    }

];

var testMode = false;
if (location.hostname === "localhost" || location.hostname === "127.0.0.1") {
    testMode = true;
}

var apiUsername = 'ecc';
var apiPassword = 'eventusg';

function getAuthorizationHeaderValue() {
    return 'Basic ' + btoa(apiUsername + ':' + apiPassword);
}

function getAccessToken(username, password, successCallback, failCallback) {
    var requestSettings = {
        "url": ccisApiUrl + "getAccessToken/",
        "method": "POST",
        "timeout": 0,
        "headers": {
            "Authorization": getAuthorizationHeaderValue()
        },
        "data": {
            'login': username,
            'password': password
        }
    };

    $.ajax(requestSettings).done(function (response) {
        successCallback(response.token);
    }).fail(function (jqXHR) {
        if (jqXHR.responseJSON) {
            failCallback(jqXHR.responseJSON.errorMessage);
            return;
        }

        if (jqXHR.status == 0) {
            failCallback('could not connect to API');
            return;
        }

        failCallback('got error status code ' + jqXHR.status + ' from API');
    });
}

function executeWorkItem(token, buConfig, workItemType, workItemId, workItemPayload, successCallback, failCallback) {
    var payloadString = JSON.stringify(workItemPayload);

    var requestSettings = {
        "url": ccisApiUrl + "workitem/",
        "method": "POST",
        "timeout": 0,
        "headers": {
            "Authorization": getAuthorizationHeaderValue()
        },
        "data": {
            'token': token,
            'cluster': buConfig.cluster,
            'pocname': buConfig.workItemPoc,
            'type': workItemType,
            'id': workItemId,
            'payload': payloadString
        }
    }

    $.ajax(requestSettings).done(function (response) {
        successCallback(response.customData);
    }).fail(function (jqXHR) {
        if (jqXHR.responseJSON) {
            failCallback(jqXHR.responseJSON.errorMessage);
            return;
        }

        if (jqXHR.status == 0) {
            failCallback('could not connect to API');
            return;
        }

        failCallback('got error status code ' + jqXHR.status + ' from API');
    });
}

function getFileContent(token, buConfig, fileType, fileName, successCallback, failCallback) {
    var requestSettings = {
        "url": ccisApiUrl + "getfile/",
        "method": "GET",
        "timeout": 0,
        "headers": {
            "Authorization": getAuthorizationHeaderValue()
        },
        "data": {
            'token': token,
            'cluster': buConfig.cluster,
            "fname": fileName,
            "ftype": fileType
        }
    };

    $.ajax(requestSettings).done(function (response) {
        successCallback(response.fbody);
    }).fail(function (jqXHR) {
        if (jqXHR.responseJSON) {
            failCallback(jqXHR.responseJSON.errorMessage);
            return;
        }

        if (jqXHR.status == 0) {
            failCallback('could not connect to API');
            return;
        }

        failCallback('got error status code ' + jqXHR.status + ' from API');
    });
}

function getGroupKvps(token, buConfig, group, partitions, successCallback, failCallback) {
    var requestSettings = {
        "url": ccisApiUrl + "groupkvps/",
        "method": "GET",
        "timeout": 0,
        "headers": {
            "Authorization": getAuthorizationHeaderValue()
        },
        "data": {
            'token': token,
            'cluster': buConfig.cluster,
            'group': group,
            'partitions': partitions
        }
    };

    $.ajax(requestSettings).done(function (response) {
        successCallback(response.modules);
    }).fail(function (jqXHR) {
        if (jqXHR.responseJSON) {
            failCallback(jqXHR.responseJSON.errorMessage);
            return;
        }

        if (jqXHR.status == 0) {
            failCallback('could not connect to API');
            return;
        }

        failCallback('got error status code ' + jqXHR.status + ' from API');
    });
}

function getTable(token, buConfig, tableName, successCallback, failCallback) {
    var requestSettings = {
        "url": ccisApiUrl + "table/",
        "method": "GET",
        "timeout": 0,
        "headers": {
            "Authorization": getAuthorizationHeaderValue()
        },
        "data": {
            'token': token,
            'cluster': buConfig.cluster,
            'tableName': tableName
        }
    };

    $.ajax(requestSettings).done(function (response) {
        successCallback(response);
    }).fail(function (jqXHR) {
        if (jqXHR.responseJSON) {
            failCallback(jqXHR.responseJSON.errorMessage);
            return;
        }

        if (jqXHR.status == 0) {
            failCallback('could not connect to API');
            return;
        }

        failCallback('got error status code ' + jqXHR.status + ' from API');
    });
}

function KvpRowViewModel(key, value) {
    var self = this;

    self.selected = ko.observable(true);
    self.key = ko.observable(key || '');
    self.value = ko.observable(value || '');

    self.previewElement = ko.observable();
    self.valueScrollLeft = ko.observable(0);
    
    self.isValueJson = ko.computed(function () {
        try {
            var valueObj = JSON.parse(self.value());
            return true;
        } catch (error) {
            return false;
        }
    });

    self.valueLineCount = ko.computed(function () {
       return self.value().split(/\r?\n/).length;
    });

    self.value.subscribe(function (newValue) {
        if (self.isValueJson()) {
            setTimeout(function () { hljs.highlightElement(self.previewElement()); }, 1);
        }
    });
}

function KvpListViewModel(initialEntryCount, defaults) {
    var self = this;

    self.entries = ko.observableArray();
    self.defaults = defaults;

    self.importTableJsonFile = ko.observable();
    self.importModuleJsonFile = ko.observable();

    self.allSelected = ko.computed({
        read: function () {
            var hasChecked = false;
            var hasUnchecked = false;

            var myEntries = self.entries();
            for (var i = 0; i < myEntries.length; i++) {
                if (myEntries[i].selected()) {
                    hasChecked = true;
                } else {
                    hasUnchecked = true;
                }
            }

            if (hasChecked && hasUnchecked) {
                return null;
            } else if (hasChecked) {
                return true;
            }

            return false;
        },
        write: function (value) {
            ko.utils.arrayForEach(self.entries(), function (entry) {
                entry.selected(value);
            });
        }
    }, this);

    self.clear = function () {
        ko.utils.arrayForEach(self.entries(), function (entry) {
            entry.selected(true);
            entry.key('');
            entry.value('');
        });
    }

    self.reset = function () {
        self.clear();

        var defaultKeys = Object.keys(self.defaults);

        self.setEntryCount(defaultKeys.length + 1);

        for (var i = 0; i < defaultKeys.length; i++) {
            var entryRow = self.entries()[i];
            entryRow.key(defaultKeys[i]);
            entryRow.value(self.defaults[defaultKeys[i]]);
        }
    }

    self.addDefaultKeys = function() {
        var defaultKeys = Object.keys(self.defaults);

        for (var i = 0; i < defaultKeys.length; i++) {
            // Find existing row?
            var entryRow = self.entries().find(function (el) { return el.key() == defaultKeys[i]; });
            if (!entryRow) {
                // We need to add the key. Can we find an empty row?
                entryRow = self.entries().find(function (el) { return el.key() == '' && el.value() === ''; });

                if (entryRow) {
                    entryRow.key(defaultKeys[i]);
                } else {
                    self.entries.push(new KvpRowViewModel(defaultKeys[i], ''));
                }
            }
        }
    }

    self.setEntryCount = function (entryCount) {
        while (entryCount > self.entries().length) {
            self.entries.push(new KvpRowViewModel());
        }
        
        if (entryCount < self.entries().length) {
            self.entries(self.entries.slice(0, entryCount));
        }
    }

    self.removeEntry = function () {
        self.entries.remove(this);
    }

    self.addNewEntry = function () {
        self.entries.push(new KvpRowViewModel());
    }

    self.loadKvps = function (kvps) {
        self.clear();
        var keys = Object.keys(kvps);

        while (self.entries().length < keys.length) {
            self.addNewEntry();
        }

        for (var i = 0; i < keys.length; i++) {
            var entryRow = self.entries()[i];
            var key = keys[i];
            var value = kvps[keys[i]];

            if (!(typeof value === 'string' || value instanceof String)) {
                value = JSON.stringify(value, null, 2);
            }

            entryRow.key(key);
            entryRow.value(value);
        }
    }

    self.readKvps = function () {
        var kvpResult = {};

        ko.utils.arrayForEach(self.entries(), function (entry) {
            var selected = entry.selected();

            if (!selected) {
                return;
            }

            var key = entry.key();
            var value = entry.value();
            
            try {
                var valueObj = JSON.parse(value);
                value = valueObj;
            } catch (error) {
                // not valid json
            }

            if (key.length > 0) {
                kvpResult[key] = value;
            }
        });

        return kvpResult;
    }

    self.loadTableEntries = function (tableEntries) {
        self.clear();

        while (self.entries().length < tableEntries.length) {
            self.addNewEntry();
        }

        for (var i = 0; i < tableEntries.length; i++) {
            var entryRow = self.entries()[i];
            var key = tableEntries[i].k;
            var value = tableEntries[i].v;

            if (!(typeof value === 'string' || value instanceof String)) {
                value = JSON.stringify(value, null, 2);
            }

            entryRow.key(key);
            entryRow.value(value);
        }
    }

    self.readTableEntries = function () {
        var tableEntries = [];

        ko.utils.arrayForEach(self.entries(), function (entry) {
            var selected = entry.selected();

            if (!selected)
                return;

            var key = entry.key();
            var value = entry.value();

            try {
                var valueObj = JSON.parse(value);
                value = valueObj;
            } catch (error) {
                // not valid json
            }

            if (key.length > 0) {
                tableEntries.push({
                    k: key,
                    v: value
                });
            }
        });

        return tableEntries;
    }

    self.exportTableJson = function (name) {
        if (!name)
            name = "table";

        var tableJson = JSON.stringify(self.readTableEntries(), null, 2);

        var dataString = "data:text/json;charset=utf-8," + encodeURIComponent(tableJson);
        var downloadAnchorNode = document.createElement('a');
        downloadAnchorNode.setAttribute("href",     dataString);
        downloadAnchorNode.setAttribute("download", name + ".json");
        document.body.appendChild(downloadAnchorNode); // required for firefox
        downloadAnchorNode.click();
        downloadAnchorNode.remove();
    }

    self.importTableJsonFile.subscribe(function (newFile) {
        if (newFile == null)
            return;
        
        var reader = new FileReader();
        reader.onload = function (event) {
            console.log(event.target.result);

            try {
                var tableData = JSON.parse(event.target.result);

                self.loadTableEntries(tableData);
            } catch (error) {
                alert('failed to parse json');
            }

            self.importTableJsonFile(null);
        };

        reader.readAsText(newFile);
    });

    self.exportModuleJson = function (name) {
        if (!name)
            name = "module";

        var tableJson = JSON.stringify(self.readKvps(), null, 2);

        var dataString = "data:text/json;charset=utf-8," + encodeURIComponent(tableJson);
        var downloadAnchorNode = document.createElement('a');
        downloadAnchorNode.setAttribute("href",     dataString);
        downloadAnchorNode.setAttribute("download", name + ".json");
        document.body.appendChild(downloadAnchorNode); // required for firefox
        downloadAnchorNode.click();
        downloadAnchorNode.remove();
    }

    self.importModuleJsonFile.subscribe(function (newFile) {
        if (newFile == null)
            return;

        var reader = new FileReader();
        reader.onload = function (event) {
            console.log(event.target.result);

            try {
                var moduleData = JSON.parse(event.target.result);

                self.loadKvps(moduleData);
            } catch (error) {
                alert('failed to parse json');
            }

            self.importModuleJsonFile(null);
        };

        reader.readAsText(newFile);
    });

    for (var i = 0; i < initialEntryCount; i++) {
        self.entries.push(new KvpRowViewModel());
    }
}

function ModuleViewModel(name, partition, defaults) {
    var self = this;

    self.name = name;
    self.defaults = defaults;
    self.partition = ko.observable(partition);
    self.entryList = new KvpListViewModel(10, defaults);
}

function CcisViewModel() {
    var self = this;

    self.authTypes = [
        "Username",
        "Session ID"
    ];
    self.authType = ko.observable(self.authTypes[0]);
    self.username = ko.observable('');
    self.password = ko.observable('');
    self.buConfig = ko.observable();
    self.saveUserInfo = ko.observable(false);
    self.token = ko.observable('');

    self.busy = ko.observable(false);

    self.modules = ko.observableArray(moduleList.map(function (m) {
        return new ModuleViewModel(m.name, m.defaultPartition, m.defaults);
    }));
    self.selectedModule = ko.observable();

    self.selectedMainTab = ko.observable('grpkvp');

    self.status = ko.observable('none');
    self.statusMessage = ko.observable('');

    self.grpkvpGroup = ko.observable('');
    self.grpkvpCorrId = ko.observable('');
    self.grpkvpPartition = ko.observable('');
    self.grpkvpMethod = ko.observable('');
    self.grpkvpStagedCorrIds = ko.observableArray();
    self.grpkvpCommittedCorrIds = ko.observableArray();
    self.grpkvpActiveCorrIds = ko.observableArray();

    self.hasToken = ko.computed(function () {
        return self.token().length > 0;
    });

    self.actionsDisabled = ko.computed(function () {
        return self.busy() || !self.hasToken();
    });

    self.grpkvpPartitionEnabled = ko.computed(function () {
        return self.grpkvpMethod() != 'status' && self.grpkvpMethod() != 'clear';
    });

    self.grpkvpPartitionAllEnabled = ko.computed(function () {
        return self.grpkvpMethod() != 'stage';
    });

    self.pocmapTfn = ko.observable('');
    self.pocmapGroup = ko.observable('');
    self.pocmapDescription = ko.observable('');
    self.pocmapSkill = ko.observable('');
    self.pocmapCorrId = ko.observable('');

    self.tblupdTableName = ko.observable('');
    self.tblupdMethod = ko.observable('');
    self.tblupdCorrId = ko.observable('');
    self.tblupdEntryList = new KvpListViewModel(10, {});
    self.tblupdImportJsonFile = ko.observable();

    self.wrkdbgType = ko.observable();
    self.wrkdbgCorrId = ko.observable();
    self.wrkdbgPayload = ko.observable();

    self.setMainTab = function (newTab) {
        self.selectedMainTab(newTab);
    }

    self.clearActiveModule = function () {
        self.selectedModule(null);
    }

    self.setActiveModule = function () {
        self.selectedModule(this);
    }

    self.setSuccessStatus = function (message) {
        self.busy(false);
        self.status('success');
        self.statusMessage(message);
        console.log('setSuccessStatus: ' + message);
    }

    self.setLoadingStatus = function (message) {
        self.busy(true);
        self.status('loading');
        self.statusMessage(message);
        console.log('setLoadingStatus: ' + message);
    }

    self.setErrorStatus = function (message) {
        self.busy(false);
        self.status('error');
        self.statusMessage(message);
        console.error('setErrorStatus: ' + message);
    }

    self.login = function () {
        var username = self.username();
        var password = self.password();

        self.setLoadingStatus('Logging in with username/password');
        getAccessToken(username, password, function (token) {
            self.token(token);
            self.setSuccessStatus('Logged in');
        }, function (error) {
            self.setErrorStatus(error);
        });
    }

    self.readSessionId = function () {
        navigator.clipboard.readText()
            .then(text => {
                if (!text.startsWith('StudioLogin')) {
                    self.setErrorStatus("Session ID wasn't found in clipboard");
                    return;
                }

                var loginParts = text.split('::');
                var tokenText = loginParts[2];
                self.token(tokenText);
                self.setSuccessStatus("Session ID read from clipboard");
            })
            .catch(err => {
                self.setErrorStatus(err);
            });
    }

    self.grpkvpRandomizeCorrId = function () {
        var correlationId = Math.floor(Math.random() * 10000000);
        self.grpkvpCorrId(correlationId);
    }

    self.grpkvpLoad = function () {
        var token = self.token();
        var buConfig = self.buConfig();
        var group = self.grpkvpGroup();

        self.setLoadingStatus('loading group ' + group + ' kvps');
        getGroupKvps(token, buConfig, group, partitionList.map(function(p) { return p.value; }), function (responseModules) {
            // Loop through all our defined modules
            ko.utils.arrayForEach(self.modules(), function (module) {
                // Try to find a response module with a matching name
                var responseModule = responseModules.find(function (m) {
                    return m.mod.substring(0, m.mod.length - 1) == module.name
                });

                if (responseModule) {
                    module.partition(responseModule.partition);
                    module.entryList.loadKvps(responseModule.kvps);
                } else {
                    module.entryList.clear();
                }

                self.setSuccessStatus('group ' + group + ' kvps loaded');
            });
        }, function (errorMessage) {
            self.setErrorStatus(errorMessage);
        });
    }

    self.grpkvpSubmit = function () {
        var token = self.token();
        var buConfig = self.buConfig();
        var corrId = self.grpkvpCorrId();
        var group = self.grpkvpGroup();
        var partition = self.grpkvpPartition();
        var method = self.grpkvpMethod();

        self.setLoadingStatus('performing action (' + method + ') on group ' + group);

        if (group.length != 5)
        {
            self.setErrorStatus('failed to perform action (invalid group #)');
            return;
        }

        var submitModules = [];
        ko.utils.arrayForEach(self.modules(), function (module) {
            var modulePartition = module.partition();

            if (modulePartition != partition)
                return;

            var kvpResults = module.entryList.readKvps();

            if (Object.keys(kvpResults).length > 0) {
                submitModules.push({
                    mod: module.name + 'M',
                    kvps: kvpResults
                });
            }
        });

        var updatePayload = {
            group: group,
            method: method
        };

        if (method == 'stage' || (method == 'commit' && partition != '')) {
            if (submitModules.length == 0) {
                self.setErrorStatus('failed to update group ' + group + ' KVPs (no kvps)');
                return;
            }

            updatePayload.partition = partition;
            updatePayload.modules = submitModules;
        }

        executeWorkItem(token, buConfig, 'grpkvp', corrId, updatePayload, function (customData) {
            self.grpkvpUpdateCorrIdLists(customData);
            self.setSuccessStatus('completed action (' + method + ') on group ' + group);
        }, function (errorMessage) {
            self.setErrorStatus(errorMessage);
        });
    }

    self.grpkvpUpdateCorrIdLists = function (customData) {
        // Clear current entries
        self.grpkvpStagedCorrIds.removeAll();
        self.grpkvpCommittedCorrIds.removeAll();
        self.grpkvpActiveCorrIds.removeAll();

        for (var i = 0; i < customData.length; i++) {
            if (customData[i].name.toLowerCase() == 'status_activecorrids' && customData[i].value.length > 0) {
                var corrIds = JSON.parse(customData[i].value);

                if (!corrIds || corrIds.length == 0)
                    continue;
                
                self.grpkvpActiveCorrIds(corrIds);
            } else if (customData[i].name.toLowerCase() == 'status_committedcorrids' && customData[i].value.length > 0) {
                var corrIds = JSON.parse(customData[i].value);

                if (!corrIds || corrIds.length == 0)
                    continue;
                
                self.grpkvpCommittedCorrIds(corrIds);
            } else if (customData[i].name.toLowerCase() == 'status_stagedcorrids' && customData[i].value.length > 0) {
                var corrIds = JSON.parse(customData[i].value);

                if (!corrIds || corrIds.length == 0)
                    continue;
                
                self.grpkvpStagedCorrIds(corrIds);
            }
        }
    }

    self.grpkvpQuickCommit = function (partition) {
        self.grpkvpRandomizeCorrId();
        self.grpkvpMethod('commit');
        self.grpkvpPartition(partition);
        self.grpkvpSubmit();
    }

    self.pocmapRandomizeCorrId = function () {
        var correlationId = Math.floor(Math.random() * 10000000);
        self.pocmapCorrId(correlationId);
    }

    self.pocmapSubmit = function () {
        var token = self.token();
        var buConfig = self.buConfig();
        var tfn = self.pocmapTfn();
        var group = self.pocmapGroup();
        var description = self.pocmapDescription();
        var skill = self.pocmapSkill();
        var corrId = self.pocmapCorrId();

        self.setLoadingStatus('mapping TFN (' + tfn + ') to group ' + group);

        if (group.length != 5) {
            self.setErrorStatus('failed TFN to group map (invalid group #)');
            return;
        }
        if (tfn.length != 10) {
            self.setErrorStatus('failed TFN to group map (invalid TFN #)');
            return;
        }
        if (skill.length < 5 || skill.length > 10) {
            self.setErrorStatus('failed TFN to group map (invalid skill #)');
            return;
        }
        if (description.length < 1) {
            self.setErrorStatus('failed TFN to group map (invalid description)');
            return;
        }

        var pocmapPayload = {
            tfn: tfn,
            skill: skill,
            group: group,
            desc: description
        };

        executeWorkItem(token, buConfig, 'pocmap', corrId, pocmapPayload, function () {
            self.setSuccessStatus('mapped TFN (' + tfn + ') to group ' + group);
        }, function (errorMessage) {
            self.setErrorStatus(errorMessage);
        });
    }

    self.tblupdLoad = function () {
        var token = self.token();
        var buConfig = self.buConfig();
        var tableName = self.tblupdTableName();

        self.setLoadingStatus('loading table ' + tableName);

        if (tableName.length == 0) {
            self.setErrorStatus('failed table load (table name)');
            return;
        }

        getTable(token, buConfig, tableName, function (table) {
            self.tblupdEntryList.loadTableEntries(table.tableValues);

            self.setSuccessStatus('loaded table ' + tableName);
        }, function (errorMessage) {
            self.setErrorStatus(errorMessage);
        });
    }

    self.tblupdSubmit = function () {
        var token = self.token();
        var buConfig = self.buConfig();
        var corrId = self.tblupdCorrId();
        var tableName = self.tblupdTableName();
        var method = self.tblupdMethod();

        self.setLoadingStatus('performing action (' + method + ') on table ' + tableName);

        if (tableName.length == 0) {
            self.setErrorStatus('failed table update (table name)');
        }

        var newEntries = this.tblupdEntryList.readTableEntries();

        var tblupdPayload = {
            tblName: tableName,
            method: method,
            table: newEntries
        };

        executeWorkItem(token, buConfig, 'tblupd', corrId, tblupdPayload, function () {
            self.setSuccessStatus('updated table ' + tableName + ' (' + method + ')');
        }, function (error) {
            self.setErrorStatus(error);
        });
    }

    self.tblupdRandomizeCorrId = function () {
        var correlationId = Math.floor(Math.random() * 10000000);
        self.tblupdCorrId(correlationId);
    }

    // Load cached username/cluster
    var localStorage = window.localStorage;

    self.saveUserInfo.subscribe(function (newValue) {
        if (!newValue) {
            localStorage.clear();
        }
    });

    self.storeUserInfo = function () {
        var saveUserInfo = self.saveUserInfo();

        if (saveUserInfo) {
            localStorage.setItem('icUsername', self.username());
            localStorage.setItem('icAuthType', self.authType());
            localStorage.setItem('icBuConfig', self.buConfig().name);
        }
    }

    self.username.subscribe(self.storeUserInfo);
    self.authType.subscribe(self.storeUserInfo);
    self.buConfig.subscribe(self.storeUserInfo);

    var cachedUsername = localStorage.getItem('icUsername');
    var cachedAuthType = localStorage.getItem('icAuthType');
    var cachedBuConfig = localStorage.getItem('icBuConfig');

    if (cachedUsername) {
        self.username(cachedUsername);
    }

    if (cachedAuthType) {
        self.authType(cachedAuthType);
    }

    if (cachedBuConfig) {
        self.buConfig(buConfigs.find(function (el) { return el.name == cachedBuConfig }));
    }

    if (cachedUsername || cachedAuthType || cachedBuConfig) {
        self.saveUserInfo(true);
    }

    self.grpkvpPartitionAllEnabled.subscribe(function (newValue) {
        if (!newValue && self.grpkvpPartition() == '') {
            self.grpkvpPartition(partitionList[0].value);
        }
    });
}

// Used for 'select all/none' checkboxes
ko.bindingHandlers.nullableChecked = {
    init: function (element, valueAccessor, allBindings, viewModel, bindingContext) {
        ko.bindingHandlers.checked.init(element, valueAccessor, allBindings, viewModel, bindingContext);
    },
    update: function (element, valueAccessor) {
        var value = valueAccessor();
        var valueUnwrapped = ko.unwrap(value);
        if (valueUnwrapped == null) {
            element.checked = false;
            element.indeterminate = true;
        } else {
            element.indeterminate = false;
        }
    }
};

ko.bindingHandlers.scrollLeft = {
    init: function (element, valueAccessor, allBindings, viewModel, bindingContext) {
        element.addEventListener('scroll', function (e) {
            var value = valueAccessor();
            value(element.scrollLeft);
        });
    },
    update: function (element, valueAccessor) {
        var value = valueAccessor();
        var valueUnwrapped = ko.unwrap(value);

        element.scrollLeft = valueUnwrapped;
    }
};

ko.bindingHandlers.fileUpload = {
    init: function (element, valueAccessor) {
        $(element).change(function () {
            valueAccessor()(element.files[0]);
        });
    },
    update: function (element, valueAccessor) {
        if (ko.unwrap(valueAccessor()) === null) {
            element.value = null;
        }
    }
};

ko.bindingHandlers.elementRef = {
    init: function (element, valueAccessor) {
        valueAccessor()(element);
    }
}
